/// <reference types="node" />
import EventEmitter from "events";
import { MockRequest } from "../types";
declare type VerboseConfiguration = {
    methods?: string[];
    dismissMocked?: boolean;
    dismissNotMocked?: boolean;
};
export declare type VerboseArgs = boolean | VerboseConfiguration;
export declare type ProviderType = "MetaMask" | "Coinbase" | "WalletConnect" | "default";
declare type ProviderConstructorArgs = {
    verbose?: VerboseArgs;
    ethTestingProviderType: ProviderType;
};
export declare class Provider extends EventEmitter {
    ethTestingProviderType: ProviderType;
    requestMocks: Record<string, MockRequest[]>;
    verbose: VerboseConfiguration;
    constructor({ verbose, ethTestingProviderType }: ProviderConstructorArgs);
    request({ method, params, }: {
        method: string;
        params?: unknown[];
    }): Promise<unknown>;
    private findMock;
    private logRequest;
}
export {};
